<?php
$data = explode("\n",file_get_contents('./capture.vcd'));

$wordIndex = 0;
$words = array($wordIndex=>'');
$timer = 0;
$dataStream = '0'; // D2
foreach ($data as $n=>$l) {
	if (!$l)
		continue; // Empty line (end of file?)
	else if ($l[0] === '$')
		continue; // commentaire
	else if ($l[0] === '#') {
		// timer
		$thisTimer = substr($l,1);
		$delta = bcsub($thisTimer,$timer);
		if (bccomp($delta,'0') < 0)
			throw new DomainException(
				"Timers are not sorted at line $n");
		if (bccomp($delta,'10000')>0) { // Arbitrary
			// We have a new word (a new char actually)
			$wordIndex++;
			$words[$wordIndex] = '';
//			echo "New word ($wordIndex)\n";
		}
		$timer = $thisTimer;
//		echo "Timer: $timer\n";
	} else if (strlen($l)!== 2)
		throw new DomainException("Invalid line length at $n");
	else if ($l[1] === '!') {
		// Clock tick
		if ($l[0] === '0')
			$words[$wordIndex] .= $dataStream;
	} else if ($l[1] === '"') {
		// Data stream
		$dataStream = $l[0];
	} else if ($l[1] === '#') {
		// Last line
		continue;
	} else
		throw new DomainException("Unparsable line at $n");
}
//foreach ($words as $w)
//	echo "$w\n";

// Simplify words, then decode
// F: 0100 0110
// C: 0100 0011
// S: 0101 0011
$decoded = array();
$offset = array(
	0,0,
	// F
	0,
	// CSC{
	1,1,1,1,1,1,1,
	// PR
	0,0,
	// ECIOUS
	1,1,1,1,1,1,1,
	// PL
	0,0,
	// EASE-S
	1,1,1,1,1,1,
	// T
	0,
	// AY-SEC
	1,1,1,1,1,1,
	// R
	0,
	// E
	1,
	// T
	0,
	// !}
	1,1);
array_pop($words); // Ignore last
foreach ($words as $i=>$w) {
//	$d = substr($w,strlen('011010000100010'),-2);
//	$d = substr($d,5) . ' ' . substr($d,5 + strlen('010'));
	$d = substr($w,-9,-1);
	$c = chr(bindec($d)+$offset[$i]);
	
	// Je cherche maintenant pourquoi les offset valent ca...
	$o = substr($w,12);
	$t = $c === ',' ? "" // "$o $o" // , ou - ? Je ne sais pas...
		: ($offset[$i] === 0 ? "$o" : "\t\t$o");
	$decoded[$i] = $d . ' ' . $c . ' ' . $i . "\t" . $t;
}

foreach ($decoded as $d)
	echo "$d\n";
// Au pif humain: mais ce sont des - ou des , ?
// FCSC{MY-PRECIOUS-PLEASE-STAY-SECRET!}
// Alors en fait, c'est que des tirets...

